unit fAboutDlg;
{
================================================================================
*
*       Application:  Clinical Observations
*       Revision:     $Revision: 9 $  $Modtime: 11/25/08 1:36p $
*       Developer:    dan.petit@domain
*       Site:         Hines OIFO
*
*       Description:  Default About Dialog
*
*       Notes:
*
*
================================================================================
*       $Archive: /CP Modernization/CliO/source/Common/forms/fAboutDlg.pas $
*
* $History: fAboutDlg.pas $
 * 
 * *****************  Version 9  *****************
 * User: Zzzzzzjuergb Date: 2/19/09    Time: 10:25a
 * Updated in $/CP Modernization/CliO/source/Common/forms
 * 
 * *****************  Version 8  *****************
 * User: Zzzzzzjuergb Date: 1/28/09    Time: 9:28a
 * Updated in $/CP Modernization/CliO/508_source/Common/forms
 * Initial cut
 * 
 * *****************  Version 6  *****************
 * User: Zzzzzzpetitd Date: 7/29/08    Time: 4:53p
 * Updated in $/CP Modernization/CliO/source/Common/forms
 * Initial b269
 * 
 * *****************  Version 5  *****************
 * User: Zzzzzzandria Date: 7/23/08    Time: 5:54p
 * Updated in $/CP Modernization/CliO/source/Common/forms
 * Build 269
 * 
 * *****************  Version 4  *****************
 * User: Zzzzzzpetitd Date: 2/21/08    Time: 1:47p
 * Updated in $/CP Modernization/CliO/source/Common/forms
 *
 * *****************  Version 3  *****************
 * User: Zzzzzzpetitd Date: 8/31/07    Time: 1:41p
 * Updated in $/CP Modernization/CliO/source/Common/forms
 *
 * *****************  Version 2  *****************
 * User: Zzzzzzpetitd Date: 2/23/07    Time: 1:53p
 * Updated in $/CP Modernization/CliO/source/Common/forms
 * Post CMO conference
 *
 * *****************  Version 1  *****************
 * User: Zzzzzzpetitd Date: 10/05/06   Time: 12:00p
 * Created in $/CP Modernization/CliO/source/Common/forms
 * Initial Check-In
 *
*
================================================================================
}
interface

uses
  Windows,
  SysUtils,
  Classes,
  Graphics,
  Forms,
  Controls,
  StdCtrls,
  Buttons,
  ExtCtrls,
  oVersionInformation;

type
  TfrmAboutDlg = class(TForm)
    Panel1: TPanel;
    lblProductName: TLabel;
    lblClientVersion: TLabel;
    lblCopyright: TLabel;
    lblReleaseDate: TLabel;
    Label2: TLabel;
    lblReleaseDateLabel: TLabel;
    Label4: TLabel;
    lblPatchLabel: TLabel;
    lblPatch: TLabel;
    Panel2: TPanel;
    ApplicationImage: TImage;
    OKButton: TButton;
    Label1: TLabel;
    lblHelpFile: TLabel;
    Panel3: TPanel;
    pnlComments: TPanel;
    lblComments: TLabel;
    lblSecurity: TLabel;
    Label3: TLabel;
    lblServerVersion: TLabel;
    lblCompileDate: TLabel;
    lblCRCValue: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    lblTestRelease: TLabel;
    lblProductNameShadow: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
  public
    procedure Execute;
  end;

var
  AboutDlg: TfrmAboutDlg;

implementation

uses
  VA508AccessibilityRouter;

{$R *.DFM}

procedure TfrmAboutDlg.Execute;
var
  IDInfo: string;
begin
  with TfrmAboutDlg.Create(Application.MainForm) do
    try
      ApplicationImage.Picture.Icon := Application.Icon;
      Font := Application.MainForm.Font;
      Position := poOwnerFormCenter;
      IDInfo :=
        Caption +
        ' C R C Value ' + lblCRCValue.Caption +
        ' product name ' + lblProductName.Caption +
        ' file version ' + lblClientVersion.Caption +
        ' server version ' + lblServerVersion.Caption;
      if lblPatchLabel.Visible then
        IDInfo := IDInfo + ' patch ' + lblPatch.Caption;
      IDInfo :=
        IDInfo +
        ' compile date ' + lblCompileDate.Caption +
        ' release date ' + lblReleaseDate.Caption +
        ' ' + lblCopyright.Caption +
        ' comments ' + lblComments.Caption;
      if lblTestRelease.Caption <> '' then
        IDInfo := IDInfo + ' ' + lblTestRelease.Caption;

      IDInfo := IDInfo + ' ' + lblSecurity.Caption;
      GetScreenReader.Speak(IDInfo);
      ShowModal;
    finally
      Free;
    end;
end;

procedure TfrmAboutDlg.FormCreate(Sender: TObject);
begin
  lblHelpFile.Caption := ExtractFileName(Application.HelpFile);
  lblHelpFile.Hint := 'Help file name: ' + Application.HelpFile;
  lblHelpFile.ShowHint := True;

  with TVersionInformation.Create(Application.ExeName, 'MD') do
    try
      Caption := 'About '+getProductName;
      lblCRCValue.Caption := getCRC32;

      lblProductName.Caption := getProductName;
      lblClientVersion.Caption := getFileVersion;
      lblServerVersion.Caption := getVAVersionNumber;
      lblPatch.Caption := getVAPatchNumber;
      lblPatchLabel.Visible := (getVAPatchNumber <> '');
      lblCompileDate.Caption := getCompiledDateTime;
      lblReleaseDate.Caption := getVAReleaseDate;
      lblCopyright.Caption := getLegalCopyRight;
      lblComments.Width := pnlComments.Width;
      lblComments.Height := pnlComments.Height;
      lblComments.Caption := getComments;
      lblTestRelease.Caption := '';
      if getDebugbuild then
        lblTestRelease.Caption := 'Debug' + #13;
      if getPreRelease then
        lblTestRelease.Caption := lblTestRelease.Caption + 'Test' + #13;
      if getSpecialBuild then
        lblTestRelease.Caption := lblTestRelease.Caption + 'Special Build' + #13;
      if getPrivateBuild then
        lblTestRelease.Caption := lblTestRelease.Caption + 'Private Build' + #13;
      if lblTestRelease.Caption <> '' then
        begin
          lblTestRelease.Caption := lblTestRelease.Caption + 'Release';
          lblTestRelease.Visible := True;
        end
      else
        lblTestRelease.Visible := False;

      lblSecurity.Caption :=
        'Developed by the Department of Veterans Affairs.'#13+
        'Unauthorized access or misuse of this system and/or its'#13+
        'data is a federal crime. Use of all data shall be'#13+
        'in accordance with VA policy on security and privacy.';
    finally
      Free;
    end;
end;

procedure TfrmAboutDlg.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if Key = VK_Escape then
    ModalResult := mrOK;
end;

end.

