unit fObservationViewer;
{
================================================================================
*
*       Application:  Clinical Observations
*       Revision:     $Revision: 22 $  $Modtime: 1/05/11 2:25p $
*       Developer:    dan.petit@domain
*       Site:         Hines OIFO
*
*       Description:  Default form for displaying an observation
*
*       Notes:
*
*
================================================================================
*       $Archive: /CP Modernization/CliO/source/Common/forms/fObservationViewer.pas $
================================================================================
}
interface

uses
  Windows,
  Messages,
  SysUtils,
  Variants,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  oInterfaces,
  oCliO,
  oCliOTypes,
  ExtCtrls,
  StdCtrls,
  Grids,
  ValEdit,
  ActnList,
  Buttons,
  ImgList,
  ComCtrls,
  ToolWin, VA508AccessibilityManager, System.ImageList, System.Actions;

type

  TfrmObservationViewer = class(TForm)
    Panel1: TPanel;
    Bevel1: TBevel;
    Bevel3: TBevel;
    pnlTop: TPanel;
    btnClose: TButton;
    ActionList1: TActionList;
    acEdit: TAction;
    acSave: TAction;
    ImageList1: TImageList;
    bbtnEdit: TBitBtn;
    bbtnSave: TBitBtn;
    Shape2: TShape;
    bbtnRescind: TBitBtn;
    acRescind: TAction;
    pnlClose: TPanel;
    pnlEdit: TPanel;
    pnlSave: TPanel;
    pnlRescind: TPanel;
    pnlAudit: TPanel;
    bbtnAudits: TBitBtn;
    acAudit: TAction;
    pnlView: TPanel;
    bbtnView: TBitBtn;
    acView: TAction;
    pnlNotice: TPanel;
    Bevel7: TBevel;
    CoolBar1: TCoolBar;
    v508AccessMgr: TVA508AccessibilityManager;
    lblNotice: TVA508StaticText;
    lblPatientName: TLabel;
    pgctrl: TPageControl;
    tbshtView: TTabSheet;
    lblObsID: TLabel;
    imgInstructions: TImage;
    tbshtAudit: TTabSheet;
    lbxAudits: TListBox;
    Panel2: TPanel;
    lblAuditDateTime: TLabel;
    lblAuditRecord: TLabel;
    scbxObsView: TScrollBox;
    cbxValue: TComboBox;
    edtValue: TEdit;
    edtObsType: TEdit;
    edtUnit: TEdit;
    cbxUnit: TComboBox;
    edtMethod: TEdit;
    cbxMethod: TComboBox;
    edtPosition: TEdit;
    cbxPosition: TComboBox;
    edtAnatomicalLocation: TEdit;
    cbxAnatomicalLocation: TComboBox;
    edtQuality: TEdit;
    cbxQuality: TComboBox;
    cbxProduct: TComboBox;
    edtProduct: TEdit;
    edtObservedBy: TEdit;
    edtObservedDateTime: TEdit;
    edtEnteredBy: TEdit;
    edtEnteredDateTime: TEdit;
    edtStatus: TEdit;
    edtSource: TEdit;
    edtSourceVersion: TEdit;
    edtSourceDataID: TEdit;
    edtSourceComments: TEdit;
    edtReasonForCorrection: TEdit;
    cbxReasonForCorrection: TComboBox;
    Label1: TLabel;
    Label2: TLabel;
    Bevel4: TBevel;
    Bevel2: TBevel;
    lblValue: TLabel;
    lblObsType: TLabel;
    lblUnit: TLabel;
    lblMethod: TLabel;
    lblPosition: TLabel;
    lblAnatomicalLocation: TLabel;
    lblQuality: TLabel;
    lblProduct: TLabel;
    lblObservedBy: TLabel;
    lblObservedDateTime: TLabel;
    lblEnteredBy: TLabel;
    lblEnteredDateTime: TLabel;
    lblStatus: TLabel;
    lblSource: TLabel;
    lblSourceVersion: TLabel;
    lblSourceDataID: TLabel;
    lblSourceComments: TLabel;
    lblReasonForCorrection: TLabel;
    lblComment: TLabel;
    btnValue: TButton;
    btnUnit: TButton;
    btnMethod: TButton;
    btnPosition: TButton;
    btnAnatomicalLocation: TButton;
    btnQuality: TButton;
    btnProduct: TButton;
    btnObservedDateTime: TButton;
    imgValue: TImage;
    imgMethod: TImage;
    imgPosition: TImage;
    imgAnatomicalLocation: TImage;
    imgQuality: TImage;
    imgProduct: TImage;
    imgReasonForCorrection: TImage;
    imgComment: TImage;
    imgUnit: TImage;
    imgObsDtTm: TImage;
    lblAuditID: TLabel;
    edtAuditID: TEdit;
    lblAuditType: TLabel;
    edtAuditType: TEdit;
    lblAuditObsID: TLabel;
    edtAuditObsID: TEdit;
    edtAuditDateTime: TEdit;
    lblAuditEdtDateTime: TLabel;
    edtAuditAuthor: TEdit;
    lblAuditAuthor: TLabel;
    edtAuditOriginalStatus: TEdit;
    lblAuditOriginalStatus: TLabel;
    edtAuditNewStatus: TEdit;
    lblAuditNewStatus: TLabel;
    edtAuditComment: TEdit;
    lblAuditComment: TLabel;
    mmoComment: TMemo;
    procedure vleEditButtonClick(Sender: TObject);
    procedure acEditExecute(Sender: TObject);
    procedure acSaveExecute(Sender: TObject);
    procedure acRescindExecute(Sender: TObject);
    procedure acAuditExecute(Sender: TObject);
    procedure acViewExecute(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure lbxAuditsClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    fCliOLoader: ICliOLoader;
    fObservation: IObservation;
    procedure LoadItems;
    procedure MakeEditReadOnly(edt: TEdit);
    procedure MakeMemoReadOnly(mmo: TMemo);
    procedure MakeEditReadWrite(edt: TEdit);
    procedure MakeMemoReadWrite(mmo: TMemo);
    procedure PaintPencil(ctrl: TWinControl);
  public
    {}
  end;

procedure DisplayObservation(aObservation: IObservation; aCliOLoader: ICliOLoader);

implementation

uses
  uGlobalVars,
  oVersionInformation,
  fSelectDateTime,
  oObservation_Audit,
  XMLDoc,
  XMLIntf,
  u508Dialogs,
  VA508AccessibilityRouter,
  Masks;

const
  PNL_HEIGHT = 30;


{$R *.dfm}

procedure DisplayObservation(aObservation: IObservation; aCliOLoader: ICliOLoader);
begin
  with TfrmObservationViewer.Create(Application.MainForm) do
    try
      fCliOLoader := aCliOLoader;

      Font := Application.MainForm.Font;
      {
      lblPatientName.Font.Style := [fsBold];
      lblPatientName.Caption := Format('%s - %s (%d)', [MyPatient.getName, MyPatient.getSex, MyPatient.getAge]);
      lblPtDOBSSN.Caption := Format('DOB: %s  SSN: %s', [FormatDateTime('mm/dd/yyyy', MyPatient.getDOB), MyPatient.getSSN]);
      lblPtWardRoomBed.Caption := Format('Ward: %s  Room/Bed: %s', [MyPatient.getWardLocation, MyPatient.getRoomBed]);
      }
      lblPatientName.Caption :=
        Format('%s - %s (%d)', [MyPatient.getName, MyPatient.getSex, MyPatient.getAge]) + #13#10 +
        Format('DOB: %s  SSN: %s', [FormatDateTime('mm/dd/yyyy', MyPatient.getDOB), MyPatient.getSSN]) + #13#10 +
        Format('Ward: %s  Room/Bed: %s', [MyPatient.getWardLocation, MyPatient.getRoomBed]);
      //
      lblObsID.Font.Style := [fsBold];
      lblObsID.Caption := Format('Observation ID: %s', [aObservation.getID]);

      fObservation := aObservation;
      tbshtView.TabVisible := False;
      tbshtAudit.TabVisible := False;

      pnlNotice.Color := clInfoBk;
      lblNotice.Color := clInfoBk;
      lblNotice.Font.Style := [fsBold];

      lblAuditDateTime.Font.Style := [fsBold];
      lblAuditRecord.Font.Style := [fsBold];

      LoadItems;

      {We can rescind if it is not a child and the user has ROLE_CLIO_MANAGER}
      pnlRescind.Visible := MyUser.HasRole(ROLE_CLIO_MANAGER) and (not Assigned(aObservation.getParent));
      pnlEdit.Visible := not MyUser.HasRole(ROLE_CLIO_READ_ONLY);
      {Audit available only to ROLE_CLIO_MANAGER}
      pnlAudit.Visible := MyUser.HasRole(ROLE_CLIO_MANAGER) and aObservation.getHasAuditLog;
      {We start on the view page}
      pnlView.Visible := False;
      pgctrl.ActivePage := tbshtView;

      {Determine editable based on status and user role}
      case aObservation.getStatus of
        osUnverified..osVerified:
          begin
            if Assigned(aObservation.getParent) then
              begin
                lblNotice.Caption := 'This observation is part of a complex observation and cannot be edited or rescinded.';
                pnlNotice.Visible := True;
                pnlEdit.Visible := False;
              end
            else
              pnlEdit.Visible := MyUser.HasRole(ROLE_CLIO_MANAGER) or
                (MyUser.getDUZ = aObservation.getEnteredByID);
          end;
      else
        begin
          lblNotice.Caption := 'This observation is in status ''' +
            OBSERVATION_STATUS[aObservation.getStatus] +
            ''' and cannot be edited.';
          pnlNotice.Visible := True;
          pnlEdit.Visible := False;
        end;
      end;

      if aObservation.isReadOnly then
      begin
        {
          We can't edit observations generated in Vitals.
        }
        lblNotice.Caption := 'Observation is read only.';
        pnlNotice.Visible := True;
        pnlEdit.Visible := False;
        pnlRescind.Visible := False;
      end;

      ShowModal;
    finally
      Free;
    end;
end;

procedure TfrmObservationViewer.LoadItems;
begin
  with fObservation do
    begin
      MakeEditReadOnly(edtValue);
      //edtValue.Text := getSValue;
      edtValue.Text := getDisplayValue;
      cbxValue.Visible := false;
      btnValue.Visible := false;
      edtValue.Visible := true;

      MakeEditReadOnly(edtObsType);
      edtObsType.Text := getTermName(ttObservation);

      {--------------}
      
      MakeEditReadOnly(edtUnit);
      edtUnit.Visible := true;
      cbxUnit.Visible := false;
      btnUnit.Visible := false;
      fObservation.getObsTerm.LoadListOfPairs(ttUnit, cbxUnit.Items);
      if assigned(fObservation.getObsUnit) then
      begin
        edtUnit.Text := fObservation.getObsUnit.getDisplayName;
      end;

      MakeEditReadOnly(edtMethod);
      fObservation.getObsTerm.LoadListOfPairs(ttMethod, cbxMethod.Items);
      edtMethod.Text := fObservation.getTermDisplayName(ttMethod);
      edtMethod.Visible := true;
      cbxMethod.Visible := false;
      btnMethod.Visible := false;

      MakeEditReadOnly(edtPosition);
      fObservation.getObsTerm.LoadListOfPairs(ttPosition, cbxPosition.Items);
      edtPosition.Text := fObservation.getTermDisplayName(ttPosition);
      edtPosition.Visible := true;
      cbxPosition.Visible := false;
      btnPosition.Visible := false;

      MakeEditReadOnly(edtAnatomicalLocation);
      fObservation.getObsTerm.LoadListOfPairs(ttLocation, cbxAnatomicalLocation.Items);
      edtAnatomicalLocation.Text := fObservation.getTermDisplayName(ttLocation);
      edtAnatomicalLocation.Visible := true;
      cbxAnatomicalLocation.Visible := false;
      btnAnatomicalLocation.Visible := false;

      MakeEditReadOnly(edtQuality);
      fObservation.getObsTerm.LoadListOfPairs(ttQuality, cbxQuality.Items);
      edtQuality.Text := fObservation.getTermDisplayName(ttQuality);
      edtQuality.Visible := true;
      cbxQuality.Visible := false;
      btnQuality.Visible := false;

      MakeEditReadOnly(edtProduct);
      fObservation.getObsTerm.LoadListOfPairs(ttProduct, cbxProduct.Items);
      edtProduct.Text := fObservation.getTermDisplayName(ttProduct);
      edtProduct.Visible := true;
      cbxProduct.Visible := false;
      btnProduct.Visible := false;

      {-------------}

      MakeEditReadOnly(edtObservedBy);
      edtObservedBy.Text := Format('%s (%s)', [getObservedBy, getObservedByID]);

      MakeEditReadOnly(edtObservedDateTime);
      edtObservedDateTime.Text := DateTimeToStr(getObservedDateTime);
      btnObservedDateTime.Visible := false;

      makeEditReadOnly(edtEnteredBy);
      edtEnteredBy.Text := Format('%s (%s)', [getEnteredBy, getEnteredByID]);
      edtEnteredDateTime.Text := DateTimeToStr(getEnteredDateTime);

      MakeEditReadOnly(edtStatus);
      edtStatus.Text := getStatusValue;
      MakeEditReadOnly(edtSource);
      edtSource.Text := getSourceID;
      MakeEditReadOnly(edtSourceVersion);
      edtSourceVersion.Text := getSourceVersion;
      MakeEditReadOnly(edtSourceDataID);
      edtSourceDataID.Text := getSourceComments;

      MakeEditReadOnly(edtSourceComments);
      edtSourceComments.Text := getSourceComments;

      MakeEditReadOnly(edtReasonForCorrection);

      MakeMemoReadOnly(mmoComment);
      mmoComment.Lines.Text := getComment;

      if getHasAuditLog then
        begin
          fCliOLoader.LoadAuditLog(lbxAudits.Items, getID);
          if lbxAudits.Items.Count > 0 then
            begin
              {Load up the first audit by default}
              lbxAudits.ItemIndex := 0;
              lbxAuditsClick(nil);
            end
          else
            pnlAudit.Visible := False;
        end;
    end;
end;

procedure TfrmObservationViewer.MakeEditReadOnly(edt: TEdit);
begin
  edt.Font.Color := clGrayText;
  edt.Font.Style := [fsBold];
  edt.ReadOnly := true;
end;

procedure TfrmObservationViewer.MakeEditReadWrite(edt: TEdit);
begin
  edt.Font.Color := clWindowText;
  edt.Font.Style := [];
  edt.ReadOnly := false;
  PaintPencil(edt);
end;

procedure TfrmObservationViewer.MakeMemoReadOnly(mmo: TMemo);
begin
  mmo.Font.Color := clGrayText;
  mmo.Font.Style := [fsBold];
  mmo.ReadOnly := true;
end;

procedure TfrmObservationViewer.MakeMemoReadWrite(mmo: TMemo);
begin
  mmo.Font.Color := clWindowText;
  mmo.Font.Style := [];
  mmo.ReadOnly := false;
  PaintPencil(mmo);
end;

procedure TfrmObservationViewer.PaintPencil(ctrl: TWinControl);
var
  img: TImage;
begin
  img := TImage(Pointer(ctrl.Tag)^);
  ImageList1.Draw(img.Canvas, 0, 0, 0);
end;

procedure TfrmObservationViewer.acEditExecute(Sender: TObject);
var
  i: integer;
begin
  if MessageDlg508(
    'You have chosen to edit this observation.' + #13 + #13 +
    'A complete audit trail of these changes will be' + #13 +
    'maintained in this patients permanent medical record.' + #13 + #13 +
    'Do you wish to proceed?', mtConfirmation, mbYesNoCancel, 0) = mrYes then
    begin
      Caption := Format('%s - Edit Mode Enabled', [Caption]);

      with imgInstructions do
        begin
          Canvas.Font := Font;
          Canvas.Font.Style := [fsBold];
          i := imgInstructions.Height - Canvas.TextHeight('|');
          Canvas.TextOut(
            1, i,
            'Items marked with ');
          ImageList1.Draw(Canvas, Canvas.TextWidth('Items marked with '), (imgInstructions.Height - ImageList1.Height) div 2, 0);
          Canvas.TextOut(
            Canvas.TextWidth('Items marked with ') + ImageList1.Width, i,
            ' are available for editing.');
        end;

      case fObservation.getObsTerm.getDataType of
      dtPickList:
        begin
          PaintPencil(cbxValue);
          fObservation.getObsTerm.LoadListOfPairs(ttValue, cbxValue.Items, tdDisplayName);
          cbxValue.ItemIndex := cbxValue.Items.IndexOf(fObservation.getDisplayValue);
          cbxValue.Visible := true;
          edtValue.Visible := false;
          btnValue.Visible := false;
        end;
      dtBoolean:
        begin
          PaintPencil(cbxValue);
          cbxValue.Items.Add(fObservation.getObsTerm.getBooleanValueFalse);
          cbxValue.Items.Add(fObservation.getObsTerm.getBooleanValueTrue);
          cbxValue.ItemIndex := cbxValue.Items.IndexOf(fObservation.getDisplayValue);
          cbxValue.Visible := true;
          edtValue.Visible := false;
          btnValue.Visible := false;
        end
      else
        begin
          MakeEditReadWrite(edtValue);
          edtValue.Text := fObservation.getSValue;
          edtValue.Visible := true;
          btnValue.Visible := false;
          cbxValue.Visible := false;
        end;
      end;

      edtEnteredBy.Text := Format('%s (%s)', [MyUser.getName, MyUser.getDUZ]);
      edtEnteredDateTime.Text := DateTimeToStr(Now);

      //edtObservedDateTime.Text := DateTimeToStr(Now);
      MakeEditReadWrite(edtObservedDateTime);
      btnObservedDateTime.Visible := true;
      btnObservedDateTime.Enabled := true;
      btnObservedDateTime.BringToFront;

      MakeMemoReadWrite(mmoComment);

      {Need that user role that says this can be verified automatically}
      edtStatus.Text := OBSERVATION_STATUS[osVerified];

      edtSource.Text := MyApplicationSource;
      edtSourceVersion.Text := '';
      edtSourceDataID.Text := '';
      edtSourceComments.Text := 'Manual Observation Correction';

      {
      for tt := Low(TTermType) to High(TTermType) do
        if tt in TERMQUALIFIERS then
          if vle.FindRow(TERMTYPE[tt], i) then
            begin
              fObservation.getObsTerm.LoadListOfPairs(tt, vle.ItemProps[TERMTYPE[tt]].PickList);
              if vle.ItemProps[TERMTYPE[tt]].PickList.Count > 0 then
                vle.ItemProps[TERMTYPE[tt]].EditStyle := esPickList
            end;
      }
      fObservation.getObsTerm.LoadListOfPairs(ttUnit, cbxUnit.Items);
      if cbxUnit.Items.Count > 0 then
      begin
        cbxUnit.Visible := true;
        cbxUnit.ItemIndex := cbxUnit.Items.IndexOf(fObservation.getTermName(ttUnit));
        PaintPencil(cbxUnit);
        edtUnit.Visible := false;
        btnUnit.Visible := false;
      end
      else
      begin
        edtUnit.Visible := true;
        cbxUnit.Visible := false;
        btnUnit.Visible := false;
      end;

      fObservation.getObsTerm.LoadListOfPairs(ttMethod, cbxMethod.Items);
      if cbxMethod.Items.Count > 0 then
      begin
        cbxMethod.Visible := true;
        cbxMethod.ItemIndex := cbxMethod.Items.IndexOf(fObservation.getTermDisplayName(ttMethod));
        PaintPencil(cbxMethod);
        edtMethod.Visible := false;
        btnMethod.Visible := false;
      end
      else
      begin
        edtMethod.Visible := true;
        cbxMethod.Visible := false;
        btnMethod.Visible := false;
      end;

      fObservation.getObsTerm.LoadListOfPairs(ttPosition, cbxPosition.Items);
      if cbxPosition.Items.Count > 0 then
      begin
        cbxPosition.Visible := true;
        cbxPosition.ItemIndex := cbxPosition.Items.IndexOf(fObservation.getTermDisplayName(ttPosition));
        PaintPencil(cbxPosition);
        edtPosition.Visible := false;
        btnPosition.Visible := false;
      end
      else
      begin
        edtPosition.Visible := true;
        cbxPosition.Visible := false;
        btnPosition.Visible := false;
      end;

      fObservation.getObsTerm.LoadListOfPairs(ttLocation, cbxAnatomicalLocation.Items);
      if cbxAnatomicalLocation.Items.Count > 0 then
      begin
        cbxAnatomicalLocation.Visible := true;
        cbxAnatomicalLocation.ItemIndex := cbxAnatomicalLocation.Items.IndexOf(fObservation.getTermDisplayName(ttLocation));
        PaintPencil(cbxAnatomicalLocation);
        edtAnatomicalLocation.Visible := false;
        btnAnatomicalLocation.Visible := false;
      end
      else
      begin
        edtAnatomicalLocation.Visible := true;
        cbxAnatomicalLocation.Visible := false;
        btnAnatomicalLocation.Visible := false;
      end;

      fObservation.getObsTerm.LoadListOfPairs(ttQuality, cbxQuality.Items);
      if cbxQuality.Items.Count > 0 then
      begin
        cbxQuality.Visible := true;
        cbxQuality.ItemIndex := cbxQuality.Items.IndexOf(fObservation.getTermDisplayName(ttQuality));
        PaintPencil(cbxQuality);
        edtQuality.Visible := false;
        btnQuality.Visible := false;
      end
      else
      begin
        edtQuality.Visible := true;
        cbxQuality.Visible := false;
        btnQuality.Visible := false;
      end;

      fObservation.getObsTerm.LoadListOfPairs(ttProduct, cbxProduct.Items);
      if cbxProduct.Items.Count > 0 then
      begin
        cbxProduct.Visible := true;
        cbxProduct.ItemIndex := cbxProduct.Items.IndexOf(fObservation.getTermDisplayName(ttProduct));
        PaintPencil(cbxProduct);
        edtProduct.Visible := false;
        btnProduct.Visible := false;
      end
      else
      begin
        edtProduct.Visible := true;
        cbxProduct.Visible := false;
        btnProduct.Visible := false;
      end;

      cbxReasonForCorrection.Visible := true;
      edtReasonForCorrection.Visible := false;
      //cbxReasonForCorrection.ItemIndex := -1;
      PaintPencil(cbxReasonForCorrection);


      {Setup the buttons for save and close only}
      pnlEdit.Visible := False;
      pnlRescind.Visible := False;
      pnlSave.Visible := True;
      btnClose.Caption := 'Cancel';
    end;
end;

procedure TfrmObservationViewer.vleEditButtonClick(Sender: TObject);
var
  aDt: TDateTime;
begin
  if Sender = btnObservedDateTime then
    begin
      aDt := StrToDateTime(edtObservedDateTime.Text);
      if EditDateTime(aDt, 'Observed') then
        edtObservedDateTime.Text := DateTimeToStr(aDt);
    end;
end;

procedure TfrmObservationViewer.acSaveExecute(Sender: TObject);
var
  aDoc: ICliOFilerDoc;
  aObs: ICliOFilerObs;
  i, j: integer;
  aQual: ITerm;
  aCorrection: IObservation;

  function getVLEValue(edt: TEdit; cbx: TComboBox): string;
  var
    aTerm: ITerm;
  begin
    if edt.Visible then
      result := edt.Text
    else
      begin
        j := cbx.Items.IndexOf(cbx.Text);
        if j > -1 then
          begin
            if assigned(cbx.Items.Objects[J]) then
            begin
              if cbx.Items.Objects[J].GetInterface(ITerm, aTerm) then
              begin
                Result := aTerm.getID
              end
            // DRM - I9397560FY16/565845 - 2017/8/3 - Boolean operators cannot be edited
            end
            // DRM - I9397560FY16/565845 ---
              else
              begin
                result := IntToStr(cbx.ItemIndex); // for dtBoolean
              end;
            // DRM - I9397560FY16/565845 - 2017/8/3 - Boolean operators cannot be edited
//            end;
            // DRM - I9397560FY16/565845 ---
          end;
      end
  end;

begin
  if cbxReasonForCorrection.Text = '' then
    begin
      MessageDlg508('Reason for Correction is required.', mtInformation, [mbOK], 0);
      Exit;
    end;

  aDoc := MyCliOFiler.getNewDocument(MyUser);
  aObs := aDoc.CreateNewObs(''); {Needs work might have a set to copy}
  with aObs do
    try
      setFacilityID(MyUser.getStation_ID);
      setPatientID(fObservation.getPatientID);
      setEnteredDateTime(Now);
      setEnteredByID(MyUser.getDUZ);
      setObservedDateTime(StrToDateTime(edtObservedDateTime.Text));
      setObservedByID(fObservation.getObservedByID);
      setTermID(fObservation.getObsTerm.getID);
      setFacilityID(fObservation.getFacilityID);
      setFacilityLocationID(fObservation.getLocationID);

      if Assigned(fObservation.getObsUnit) then
        setUnitID(fObservation.getObsUnit.getID);

      setValue(getVLEValue(edtValue, cbxValue));

      {Add this correction to every set the original was in}
      for i := 0 to fObservation.getSetCount - 1 do
        AddToSet(fObservation.getSetID(i));

      {Get the Qualifiers}
      {for tt := Low(TTermType) to High(TTermType) do
        if tt in TERMQUALIFIERS then
          if vle.FindRow(TERMTYPE[tt], i) then
            if vle.Values[TERMTYPE[tt]] <> '' then
              begin
                j := vle.ItemProps[TERMTYPE[tt]].PickList.IndexOf(vle.Values[TERMTYPE[tt]]);
                if j > -1 then
                  begin
                    vle.ItemProps[TERMTYPE[tt]].PickList.Objects[j].GetInterface(ITerm, aQual);
                    setQualifier(tt, aQual.getID)
                  end
                else
                  MessageDlg508('Error getting ' + TERMTYPE[tt] + ' qualifier', mtError, [mbOk], 0);
              end;
      }

      { DanP - 12/29/2010 - Users can change the units as well }
      j := cbxUnit.ItemIndex;
      if j > -1 then
      begin
        cbxUnit.Items.Objects[j].GetInterface(ITerm, aQual);
        setQualifier(ttUnit, aQual.getID);
      end;

      j := cbxMethod.ItemIndex;
      if j > -1 then
      begin
        cbxMethod.Items.Objects[j].GetInterface(ITerm, aQual);
        setQualifier(ttMethod, aQual.getID);
      end;

      j := cbxPosition.ItemIndex;
      if j > -1 then
      begin
        cbxPosition.Items.Objects[j].GetInterface(ITerm, aQual);
        setQualifier(ttPosition, aQual.getID);
      end;

      j := cbxAnatomicalLocation.ItemIndex;
      if j > -1 then
      begin
        cbxAnatomicalLocation.Items.Objects[j].GetInterface(ITerm, aQual);
        setQualifier(ttLocation, aQual.getID);
      end;

      j := cbxQuality.ItemIndex;
      if j > -1 then
      begin
        cbxQuality.Items.Objects[j].GetInterface(ITerm, aQual);
        setQualifier(ttQuality, aQual.getID);
      end;

      j := cbxProduct.ItemIndex;
      if j > -1 then
      begin
        cbxProduct.Items.Objects[j].GetInterface(ITerm, aQual);
        setQualifier(ttProduct, aQual.getID);
      end;

      setComment(mmoComment.Lines.Text);
      //setSource(Format('Correction by %s (%s)', [MyUser.getName, MyUser.getDUZ]));
      {Hello Biz Rule!!!}

      if MyUser.HasRole('MD TRAINEE') then
        setObservationStatus(osUnverified)
      else
        setObservationStatus(osVerified);

      MyCliOFiler.Execute(aDoc);

      aCorrection := MyCliOLoader.GetObservationByID(aObs.getID);

      MyCliOFiler.Correct(fObservation, aCorrection, MyUser, cbxReasonForCorrection.Text);

      ModalResult := mrOk;
    except
      on E: Exception do
        ShowMessage(E.Message);
    end;
end;

procedure TfrmObservationViewer.acRescindExecute(Sender: TObject);
var
  aReason: string;
begin
  if MessageDlg508(
    'You have chosen to rescind this observation.' + #13 + #13 +
    'A complete audit trail of this change will be ' +
    'maintained in this patients permanent medical record ' +
    'however this observation will no longer be available during ' +
    'normal clinical operations.' + #13 + #13 +
    'Do you wish to proceed?', mtConfirmation, mbYesNoCancel, 0) = mrYes then
    if InputQuery('Rescind Observation', 'Reason for rescission:', aReason) then
      if Length(aReason) > 0 then
        begin
          MyCliOFiler.UpdateObservationAsRescinded(fObservation, MyUser, aReason);
          ModalResult := mrOK;
        end
      else
        MessageDlg508('Sorry, you must enter a reason for rescinding this item.', mtError, [mbOk], 0);
end;

procedure TfrmObservationViewer.acAuditExecute(Sender: TObject);
begin
  pnlView.Visible := True;
  pnlAudit.Visible := False;
  pgctrl.ActivePage := tbshtAudit;
end;

procedure TfrmObservationViewer.acViewExecute(Sender: TObject);
begin
  pnlView.Visible := False;
  pnlAudit.Visible := True;
  pgctrl.ActivePage := tbshtView;
end;

procedure TfrmObservationViewer.FormActivate(Sender: TObject);
var
  I: Integer;
//  Item: TVA508AccessibilityItem;
begin
  for I := 0 to v508AccessMgr.AccessData.Count - 1 do
  begin
    if v508AccessMgr.AccessData[I].Component = scbxObsView then
    begin
      v508AccessMgr.AccessData[I].AccessText := lblObsID.Caption;
    end;
  end;
end;

procedure TfrmObservationViewer.FormClose(Sender: TObject; var Action: TCloseAction);
var
  i: integer;
begin
  for i := 0 to lbxAudits.Items.Count - 1 do
    begin
      lbxAudits.Items.Objects[i].Free;
      lbxAudits.Items.Objects[i] := nil;
    end;
  Action := caFree;
end;

procedure TfrmObservationViewer.FormCreate(Sender: TObject);
begin
  edtValue.Tag := Integer(@imgValue);
  cbxValue.Tag := Integer(@imgValue);
  edtUnit.Tag := Integer(@imgUnit);
  cbxUnit.Tag := Integer(@imgUnit);
  edtMethod.Tag := Integer(@imgMethod);
  cbxMethod.Tag := Integer(@imgMethod);
  edtPosition.Tag := Integer(@imgPosition);
  cbxPosition.Tag := Integer(@imgPosition);
  edtAnatomicalLocation.Tag := Integer(@imgAnatomicalLocation);
  cbxAnatomicalLocation.Tag := Integer(@imgAnatomicalLocation);
  edtQuality.Tag := Integer(@imgQuality);
  cbxQuality.Tag := Integer(@imgQuality);
  edtProduct.Tag := Integer(@imgProduct);
  cbxProduct.Tag := Integer(@imgProduct);
  cbxReasonForCorrection.Tag := Integer(@imgReasonForCorrection);
  mmoComment.Tag := Integer(@imgComment);
  edtObservedDateTime.Tag := Integer(@imgObsDtTm);
end;

procedure TfrmObservationViewer.lbxAuditsClick(Sender: TObject);
var
  Audit: TStringList;
begin
  Audit := TStringList.Create;
  try
    if lbxAudits.ItemIndex > -1 then
      TObservation_Audit(lbxAudits.Items.Objects[lbxAudits.ItemIndex]).Display(Audit);


    edtAuditID.Text := Audit.Values['ID'];
    edtAuditType.Text := Audit.Values['Audit Type'];
    edtAuditObsID.Text := Audit.Values['Observation ID'];
    edtAuditDateTime.Text := Audit.Values['Audit Date/Time'];
    edtAuditAuthor.Text := Audit.Values['Author'];
    edtAuditOriginalStatus.Text := Audit.Values['Original Status'];
    edtAuditNewStatus.Text := Audit.Values['New Status'];
    edtAuditComment.Text := Audit.Values['Comment'];
  finally
    FreeAndNil(Audit);
  end;
end;


end.

