unit oCPKardexAudit;
{
================================================================================
*
*       Application:  Clinical Observations
*       Revision:     $Revision: 1 $  $Modtime: 6/15/08 3:34p $
*       Developer:    dan.petit@domain
*       Site:         Hines OIFO
*
*       Description:  Primary Care Action Object
*
*       Notes:
*
*
================================================================================
* $Archive: /CP Modernization/CliO/source/Common/objects/oCPKardexAudit.pas $
================================================================================
}
interface

uses
  Classes,
  ComCtrls,
  oCPTypes,
  oCliOTypes,
  oInterfaces,
  Graphics,
  SysUtils,
  XMLDoc,
  XMLIntf;

type
  TCPKardexAudit = class(TInterfacedObject, ICPKardexAudit)
  private
    fEventID: string;
    fActionID: string;
    fAuditDateTime: TDateTime;
    fAuditByID: string;
    fDescription: string;
    fComment: string;
  public
    constructor Create;
    destructor Destroy; override;

    {Public methods available to oCPKardexService}
    function LoadFromXML(aXMLNode: IXMLNode): boolean;

    {ICPKardexEvent methods}
    function getEventID: string; stdcall;
    function getActionID: string; stdcall;
    function getAuditDateTime: TDateTime; stdcall;
    function getAuditByID: string; stdcall;
    function getDescription: string; stdcall;
    function getComment: string; stdcall;

    procedure AddToList(aList: TStrings); stdcall;
  end;

implementation

uses
  oCP_Exceptions,
  uCPXML;

{ TCPKardexAudit }

constructor TCPKardexAudit.Create;
begin
  inherited;
end;

destructor TCPKardexAudit.Destroy;
begin
  inherited;
end;

procedure TCPKardexAudit.AddToList(aList: TStrings);
begin
  aList.AddObject(fDescription, Self);
end;

function TCPKardexAudit.getActionID: string;
begin
  Result := fActionID;
end;

function TCPKardexAudit.getAuditByID: string;
begin
  Result := fAuditByID;
end;

function TCPKardexAudit.getAuditDateTime: TDateTime;
begin
  Result := fAuditDateTime;
end;

function TCPKardexAudit.getComment: string;
begin
  Result := fComment;
end;

function TCPKardexAudit.getDescription: string;
begin
  Result := fDescription;
end;

function TCPKardexAudit.getEventID: string;
begin
  Result := fEventID;
end;

function TCPKardexAudit.LoadFromXML(aXMLNode: IXMLNode): boolean;
begin
  try
    fActionID := XMLValueAsStr(aXMLNode, 'ACTION_ID');
    fEventID := XMLValueAsStr(aXMLNode, 'EVENT_ID');
    fAuditDateTime := XMLValueAsDateTime(aXMLNode, 'AUDIT_DATE_TIME');
    fAuditByID := XMLValueAsStr(aXMLNode, 'AUDIT_BY_ID');
    fComment := XMLValueAsStr(aXMLNode, 'AUDIT_COMMENT');
    fDescription := XMLValueAsStr(aXMLNode, 'AUDIT_DESCRIPTION');
    Result := True;
  except
    Result := False;
  end;
end;

end.

