unit oCPPerson;

interface

uses
  Classes,
  XMLDoc,
  XMLIntf,
  uCPXML,
  oCliO,
  oInterfaces;

type
  TCPPerson = class(TInterfacedObject, IPerson)
  protected
    fID: string;
    fName: string;
    fInitials: string;
    fSex: string;
    fSSN: string;
    fDOB: TDateTime;
    fTitle: string;
    fStationID: string;
    fStationName: string;

    function getID: string; stdcall;
    function getName: string; stdcall;
    function getInitials: string; stdcall;
    function getSex: string; stdcall;
    function getSSN: string; stdcall;
    function getDOB: TDateTime; stdcall;
    function getTitle: string; stdcall;
    function getStationID: string; stdcall;
    function getStationName: string; stdcall;

    procedure AddToList(aList: TStrings); stdcall;

    procedure LoadFromXML(aXMLNode: IXMLNode);
  public
    constructor Create(aXMLNode: IXMLNode);
    destructor Destroy; override;
  end;

implementation

{ TCPUser }

procedure TCPPerson.AddToList(aList: TStrings);
begin
  aList.AddObject(fName, Self);
end;

constructor TCPPerson.Create(aXMLNode: IXMLNode);
begin
  inherited Create;
  LoadFromXML(aXMLNode);
end;

destructor TCPPerson.Destroy;
begin
  inherited;
end;

function TCPPerson.getDOB: TDateTime;
begin
  Result := fDOB;
end;

function TCPPerson.getID: string;
begin
  Result := fID;
end;

function TCPPerson.getInitials: string;
begin
  Result := fInitials;
end;

function TCPPerson.getName: string;
begin
  Result := fName;
end;

function TCPPerson.getSex: string;
begin
  Result := fSex;
end;

function TCPPerson.getSSN: string;
begin
  Result := fSSN;
end;

function TCPPerson.getStationID: string;
begin
  Result := fStationID;
end;

function TCPPerson.getStationName: string;
begin
  Result := fStationName;
end;

function TCPPerson.getTitle: string;
begin
  Result := fTitle;
end;

procedure TCPPerson.LoadFromXML(aXMLNode: IXMLNode);
begin
  fID := XMLValueAsStr(aXMLNode, 'ID');
  fName := XMLValueAsStr(aXMLNode, 'NAME');
  fInitials := XMLValueAsStr(aXMLNode, 'INITIAL');
  fSex := XMLValueAsStr(aXMLNode, 'SEX');
  fSSN := XMLValueAsStr(aXMLNode, 'SSN');
  fDOB := XMLValueAsDateTime(aXMLNode, 'DOB');
  fTitle := XMLValueAsStr(aXMLNode, 'TITLE');
end;

end.

