unit oCliOLogEntry;

interface

uses
  Classes,
  SysUtils,
  ComCtrls,
  oCliO,
  oCliOTypes,
  oInterfaces,
  uCPXML,
  XMLIntf;

type
  TCliOLogEntry = class(TInterfacedObject, ICliOLogEntry)
  private
    fDateTime: TDateTime;
    fStatus: TObservationRecordStatus;
    fPatientID: string;
    function getDateTime: TDateTime; stdcall;
    function getStatus: TObservationRecordStatus; stdcall;
    function getPatientID: string; stdcall;
    procedure AddToTreeView(aTTreeNode: TTreeNode); stdcall;
  end;

function NewCliOLogEntry(aXMLNode: IXMLNode): ICliOLogEntry;

implementation

function NewCliOLogEntry(aXMLNode: IXMLNode): ICliOLogEntry;
begin
  with TCliOLogEntry.Create do
    try
      fDateTime := XMLValueAsDateTime(aXMLNode, 'OBSERVED_DATE_TIME');
      fStatus := TObservationRecordStatus(XMLValueAsInt(aXMLNode, 'STATUS', 0));
      fPatientID := XMLValueAsStr(aXMLNode, 'PATIENT_ID');
      GetInterface(ICliOLogEntry, Result);
    except
      Free;
      Result := nil;
    end;
end;

{ TCliOLogEntry }

procedure TCliOLogEntry.AddToTreeView(aTTreeNode: TTreeNode);
begin
  TTreeView(aTTreeNode.TreeView).Items.AddChildObject(aTTreeNode, FormatDateTime('YYYY-MM-DD HH:MM:SS', fDateTime), Self);

end;

function TCliOLogEntry.getDateTime: TDateTime;
begin
  Result := fDateTime;
end;

function TCliOLogEntry.getPatientID: string;
begin
  Result := fPatientID;
end;

function TCliOLogEntry.getStatus: TObservationRecordStatus;
begin
  Result := fStatus;
end;

end.

