unit oCliOReportWriter;

interface

uses
  Classes,
  oInterfaces,
  SysUtils,
  ExtCtrls,
  Graphics;

type
  TCliOReportJustification = (rjLeft, rjRight, rjCenter);

  ICliOReport = interface;
  ICliOReportSection = interface;
  ICliOReportColumn = interface;
  ICliOReportItem = interface;

  ICliOReport = interface(IInterface)
    ['{D410E9F6-65E8-491B-80FF-9E75FF228602}']
    procedure setTitle(aValue: string); stdcall;
    procedure setPatient(aPatient: IPatient); stdcall;
    procedure setDateTimeRange(aStartDate, aStopDate: TDateTime); stdcall;

    function NewSection: ICliOReportSection; stdcall;
    function XML: string; stdcall;

    procedure Preview(aImage: TImage); stdcall;
    procedure Print; stdcall;
    procedure WriteNote(aNoteText: TStrings); stdcall;
    procedure Clear; stdcall;
  end;

  ICliOReportSection = interface(IInterface)
    ['{D4EB4C9A-1DC3-4B4D-8D85-D2405F060207}']
    function getTitle: string; stdcall;
    function getPrintHeader: boolean; stdcall;
    function getPrintSubHeader: boolean; stdcall;
    function getTopLevel: boolean; stdcall;

    procedure setTitle(aValue: string); stdcall;
    procedure setPrintHeader(aValue: boolean); stdcall;
    procedure setPrintSubHeader(aValue: boolean); stdcall;
    procedure setTopLevel(aValue: boolean); stdcall;

    function FirstColumn: ICliOReportColumn; stdcall;
    function NextColumn(aCliOReportColumn: ICliOReportColumn): ICliOReportColumn; stdcall;

    function Column(aIndex: Integer): ICliOReportColumn; stdcall;
    function ColumnCount: Integer; stdcall;

    function Item(aIndex: Integer): ICliOReportItem; stdcall;
    function ItemCount: integer; stdcall;

    function NewColumn: ICliOReportColumn; stdcall;
    function NewItem: ICliOReportItem; stdcall;
  end;

  ICliOReportColumn = interface(IInterface)
    ['{BDD2A510-A81B-4BE3-A3D7-DCEBAB374B75}']
    function getTitle: string; stdcall;
    function getWidth: double; stdcall;
    function getJustification: TCliOReportJustification; stdcall;

    procedure setTitle(aValue: string); stdcall;
    procedure setWidth(aValue: double); stdcall;
    procedure setJustification(aValue: TCliOReportJustification); stdcall;
  end;

  ICliOReportItem = interface(IInterface)
    ['{5B742590-A2B4-44B3-9140-C6914454CC77}']
    function getValue(aColumn: integer): string; stdcall;
    function getLine: string; stdcall;
    function getFontStyle: TFontStyles; stdcall;

    procedure setValue(aColumn: integer; aValue: string); stdcall;
    procedure setLine(aValue: string); stdcall;
    procedure setFontBold(aValue: boolean); stdcall;
    procedure setFontItalic(aValue: boolean); stdcall;
    procedure setFontUnderline(aValue: boolean); stdcall;
    procedure setFontStrikeThrough(aValue: boolean); stdcall;
  end;

function NewCliOReport: ICliOReport;

implementation

uses
  oCliOReport;

function NewCliOReport: ICliOReport;
begin
  TCliOReport.Create.GetInterface(ICliOReport, Result);
end;

end.

