unit oDBConnection_J2EE;
{
================================================================================
*
*       Application:  Clinical Observations
*       Revision:     $Revision: 3 $  $Modtime: 5/22/09 1:08p $
*       Developer:    dan.petit@domain
*       Site:         Hines OIFO
*
*       Description:  Standard J2EE service connector for IDBConnection
*
*       Notes:
*
*
================================================================================
*       $Archive: /CP Modernization/CliO/source/Common/objects/oDBConnection_J2EE.pas $
*
* $History: oDBConnection_J2EE.pas $
 * 
 * *****************  Version 3  *****************
 * User: Zzzzzzjuergb Date: 5/22/09    Time: 2:17p
 * Updated in $/CP Modernization/CliO/source/Common/objects
 * Build Pre-275:  
 * 
 * *****************  Version 2  *****************
 * User: Zzzzzzpetitd Date: 4/08/08    Time: 8:13p
 * Updated in $/CP Modernization/CliO/source/Common/objects
 * 
 * *****************  Version 1  *****************
 * User: Zzzzzzpetitd Date: 11/10/07   Time: 1:16p
 * Created in $/CP Modernization/CliO/source/Common/objects
 * 
 * *****************  Version 2  *****************
 * User: Zzzzzzpetitd Date: 10/27/06   Time: 3:00p
 * Updated in $/CP Modernization/CliO/source/Common/objects
 *
 * *****************  Version 1  *****************
 * User: Zzzzzzpetitd Date: 10/05/06   Time: 12:06p
 * Created in $/CP Modernization/CliO/source/Common/objects
 * Initial Check-In
 *
*
================================================================================
}
interface

uses
  SysUtils,
  Windows,
  Messages,
  Classes,
  Graphics,
  Controls,
  Forms,
  XMLDoc,
  XMLIntf,
  oInterfaces;

type
  TDBConnection_J2EE = class(TInterfacedObject, IDBConnection)
  public
    constructor Create;
    destructor Destroy; override;
    function InitCommands(aCommandFileName: string): Boolean; stdcall;
    procedure BeginTransaction; stdcall;
    procedure CommitTransaction; stdcall;
    function Connect(aParams: array of Variant): Boolean; stdcall;
    procedure Disconnect; stdcall;
    function ExecCommand(aCommandName: string; aParams: array of variant): Boolean; stdcall;
    function ExecQuery(aQueryName: string; aParams: array of variant; aResults: IXMLDocument): boolean; stdcall;
    function ExecResults: TStringList; stdcall;
    function ExecStoredProc(aStoredProcName: string; aParams: array of variant; aParamList: TStringList): Boolean; stdcall;
    function getDescription: string; stdcall;
    function IsConnected: Boolean; stdcall;
    procedure RollbackTransaction; stdcall;
    procedure SaveCommandList(aFileName: string); stdcall;
  end;

implementation

{ TDBConnection_J2EE }

{
************************************************** TDBConnection_J2EE **************************************************
}

constructor TDBConnection_J2EE.Create;
begin
  inherited Create;
end;

destructor TDBConnection_J2EE.Destroy;
begin
  inherited;
end;

function TDBConnection_J2EE.InitCommands(aCommandFileName: string): boolean;
begin
  //
  result := false;
end;

procedure TDBConnection_J2EE.BeginTransaction;
begin
  //
end;

procedure TDBConnection_J2EE.CommitTransaction;
begin

end;

function TDBConnection_J2EE.Connect(aParams: array of Variant): Boolean;
begin
  Result := False;
end;

procedure TDBConnection_J2EE.Disconnect;
begin
  //
end;

function TDBConnection_J2EE.ExecCommand(aCommandName: string; aParams: array of variant): Boolean;
begin
  result := false;
end;

function TDBConnection_J2EE.ExecQuery(aQueryName: string; aParams: array of variant; aResults: IXMLDocument): boolean;
begin
  result := false;
end;

function TDBConnection_J2EE.ExecResults: TStringList;
begin
  result := nil;
end;

function TDBConnection_J2EE.ExecStoredProc(aStoredProcName: string; aParams: array of variant; aParamList:
  TStringList): Boolean;
begin
  //
  result := false;
end;

function TDBConnection_J2EE.getDescription: string;
begin
  Result := 'Connection to a J2EE service provider';
end;

function TDBConnection_J2EE.IsConnected: Boolean;
begin
  Result := False;
end;

procedure TDBConnection_J2EE.RollbackTransaction;
begin

end;

procedure TDBConnection_J2EE.SaveCommandList(aFileName: string);
begin
  //
end;

end.

