unit oDBConnection_MSAccess;
{
================================================================================
*
*       Application:  Clinical Observations
*       Revision:     $Revision: 1 $  $Modtime: 11/10/07 12:39p $
*       Developer:    dan.petit@domain
*       Site:         Hines OIFO
*
*       Description:  Standard MS-Access connector for IDBConnection
*
*       Notes:
*
*
================================================================================
*       $Archive: /CP Modernization/CliO/source/Common/objects/oDBConnection_MSAccess.pas $
*
* $History: oDBConnection_MSAccess.pas $
 * 
 * *****************  Version 1  *****************
 * User: Zzzzzzpetitd Date: 11/10/07   Time: 1:16p
 * Created in $/CP Modernization/CliO/source/Common/objects
 * 
 * *****************  Version 1  *****************
 * User: Zzzzzzpetitd Date: 10/05/06   Time: 12:06p
 * Created in $/CP Modernization/CliO/source/Common/objects
 * Initial Check-In
 *
*
================================================================================
}
interface

uses
  SysUtils,
  Windows,
  Messages,
  Classes,
  Graphics,
  Controls,
  Forms,
  oInterfaces,
  oDBConnection_ADO;

type
  TDBConnection_MSAccess = class(TDBConnection_ADO, IDBConnection)
  private
    fConnectionString: string;
    fFileName: string;
  public
    constructor Create;
    destructor Destroy; override;
    function Connect(aParams: array of variant): Boolean; stdcall;
    function getDescription: string; stdcall;
  end;

implementation

const
  CONN_STR = 'Provider=Microsoft.Jet.OLEDB.4.0;Data Source=%s;Persist Security Info=False';

{
************************************************ TDBConnection_MSAccess ************************************************
}

constructor TDBConnection_MSAccess.Create;
begin
  inherited Create;
end;

destructor TDBConnection_MSAccess.Destroy;
begin
  inherited;
end;

function TDBConnection_MSAccess.Connect(aParams: array of variant): Boolean;
begin
  Result := False;
  fFileName := aParams[0];
  if FileExists(fFileName) then
    try
      fConnectionString := Format(CONN_STR, [fFileName]);
      Result := ConnectADO(fConnectionString);
    except
      Result := False;
    end;
end;

function TDBConnection_MSAccess.getDescription: string;
begin
  Result := Format('MS Access DB in %s', [fFilename]);
end;

end.

