unit oDBController_Kardex;
{
================================================================================
*
*       Application:  Clinical Observations
*       Revision:     $Revision: 1 $  $Modtime: 5/06/08 1:33p $
*       Developer:    dan.petit@domain
*       Site:         Hines OIFO
*
*       Description:  Primary controller for interacting with Nursing Care
*                     Actions
*
*       Notes:
*
*
================================================================================
*       $Archive: /CP Modernization/CliO/source/Common/objects/oDBController_Kardex.pas $
================================================================================
}
interface

uses
  SysUtils,
  Windows,
  Messages,
  Classes,
  oInterfaces,
  oCliO,
  oCliOTypes,
  oDBController,
  oCP_Exceptions,
  XMLDoc,
  XMLIntf;

type
  TDBController_Kardex = class(TDBController, ICPKardex)
  private
    fTerminology: ITerminology;
    fPatient: IPatient;
    fOrders: IInterfaceList;
  public
    constructor Create;
    destructor Destroy; override;

    procedure Load(aPatient: IPatient);
  end;

function NewObservationController(aTerminology: ITerminology): TDBController_Kardex;

implementation

uses
  uCPXML,
  DateUtils,
  Variants;

function NewObservationController(aTerminology: ITerminology): TDBController_Kardex;
begin
  Result := TDBController_Kardex.Create;
  aTerminology.QueryInterface(ITerminology, Result.fTerminology);
end;

{------------------------------------------------------------------------------}
{------------------------- TDBController_CareActions --------------------------}
{------------------------------------------------------------------------------}

constructor TDBController_Kardex.Create;
begin
  inherited;
end;

destructor TDBController_Kardex.Destroy;
begin
  inherited;
end;

procedure TDBController_Kardex.Load(aPatient: IPatient);
begin
  try
    //aXMLDoc := NewXMLDocument;
    (*
    {Load the views}
    if not DBConnection.ExecQuery('GetViewList', [], aXMLDoc) then
      raise ECPLoadControllerFail.Create('Error loading View definitions.');

    aXMLDoc.Active := True;
    aXMLNode := XMLDocumentFirstRecord(aXMLDoc);
    while Assigned(aXMLNode) do
      begin
        aView := NewObservationView(aXMLNode, DBConnection, fTerminology);
        if Assigned(aView) then
          fViews.Add(aView)
        else
          raise ECPLoadControllerFail.Create('Error loading view:' + #13 + aXMLNode.XML);
        aXMLNode := XMLDocumentNextRecord(aXMLNode);
      end;
    *)

    (*
    {Load Reports}
    if not DBConnection.ExecQuery('GetReportList', [], aXMLDoc) then
      raise ECPLoadControllerFail.Create('Error loading reports');

    aXMLDoc.Active := True;
    //aXMLSaveToFile('.\GetReportList.xml');
    aXMLNode := XMLDocumentFirstRecord(aXMLDoc);
    while aXMLNode <> nil do
      try
        NewCliOReport(DBConnection, fTerminology, aXMLNode).GetInterface(ICliOReport, aReport);
        fReports.Add(aReport);
      finally
        aXMLNode := XMLDocumentNextRecord(aXMLNode);
      end;
    *)
  except
    on E: ECPException do
      raise;
    on E: Exception do
      raise ECPLoadControllerFail.CreateFmt('Unknown load error %s.', [E.Message]);
  end;
end;

end.

